Index: /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env	(revision 1615)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env	(revision 1616)
@@ -1,5 +1,6 @@
 module unload netcdf-c netcdf-fortran hdf5 flavor perl hdf5 boost blitz mpi gnu
 module load gnu
-module load mpi/openmpi/2.0.2
+module unload mpi/openmpi/2.0.2
+module load mpi/intelmpi
 module load flavor/hdf5/parallel
 module load netcdf-fortran/4.4.4
Index: /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm	(revision 1615)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm	(revision 1616)
@@ -2,6 +2,8 @@
 ###################                Projet XIOS               ###################
 ################################################################################
-
-%CCOMPILER      mpicc -qopenmp -D_usingEP -D_intelmpi -std=c++11
+#
+# compile XIOS with local netcdf and hdf5 with intelmpi
+#
+%CCOMPILER      mpicc -qopenmp -D_usingEP -D_intelmpi
 %FCOMPILER      mpif90 -qopenmp
 %LINKER         mpif90 -qopenmp -nofor-main -Wl,-rpath -Wl,$HOME/lib/netcdf_f_intel/lib
Index: /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.env
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.env	(revision 1616)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.env	(revision 1616)
@@ -0,0 +1,13 @@
+module switch mpi mpi/intelmpi
+module unload netcdf-c netcdf-fortran hdf5 flavor perl hdf5 boost blitz mpi gnu
+module load gnu
+#module load mpi/openmpi/2.0.2
+#module load mpi/intelmpi/2017
+module load flavor/buildcompiler/intel/17
+module load flavor/buildmpi/intelmpi/2017
+module load flavor/hdf5/parallel
+module load netcdf-fortran/4.4.4
+module load hdf5/1.8.20
+module load boost
+module load blitz
+module load feature/bridge/heterogenous_mpmd
Index: /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.fcm
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.fcm	(revision 1616)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.fcm	(revision 1616)
@@ -0,0 +1,29 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+#
+# Compile XIOS with intelmpi
+#
+
+%CCOMPILER      mpicc -qopenmp -D_usingEP -D_intelmpi
+%FCOMPILER      mpif90 -qopenmp
+%LINKER         mpif90 -qopenmp -nofor-main
+
+%BASE_CFLAGS    -std=c++11 -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+#%DEV_CFLAGS     -g -traceback
+%DEV_CFLAGS     -g 
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+#%DEV_FFLAGS     -g -traceback
+%DEV_FFLAGS     -g 
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            mpicc -EP
+%FPP            cpp -P
+%MAKE           gmake
Index: /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.path
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.path	(revision 1616)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-X64_IRENE_omp.path	(revision 1616)
@@ -0,0 +1,28 @@
+NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR"
+NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR"
+NETCDF_LIB="-lnetcdf -lnetcdff"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I$HDF5_INCDIR"
+HDF5_LIBDIR="-L$HDF5_LIBDIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
+
+BOOST_INCDIR="-I $BOOST_INCDIR"
+BOOST_LIBDIR="-L $BOOST_LIBDIR"
+BOOST_LIB=""
+
+BLITZ_INCDIR="-I $BLITZ_INCDIR"
+BLITZ_LIBDIR="-L $BLITZ_LIBDIR"
+BLITZ_LIB=""
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
+
+
+#only for MEMTRACK debuging : developper only
+ADDR2LINE_LIBDIR="-L${WORKDIR}/ADDR2LINE_LIB"
+ADDR2LINE_LIB="-laddr2line"