Index: XIOS/trunk/src/io/inetcdf4.cpp
===================================================================
--- XIOS/trunk/src/io/inetcdf4.cpp	(revision 1638)
+++ XIOS/trunk/src/io/inetcdf4.cpp	(revision 1639)
@@ -7,5 +7,5 @@
 namespace xios
 {
-  CINetCDF4::CINetCDF4(const StdString& filename, const ep_lib::MPI_Comm* comm /*= NULL*/, bool multifile /*= true*/,
+  CINetCDF4::CINetCDF4(const StdString& filename, const MPI_Comm* comm /*= NULL*/, bool multifile /*= true*/,
                        bool readMetaDataPar /*= false*/, const StdString& timeCounterName /*= "time_counter"*/)
   {
@@ -14,5 +14,5 @@
     {
       int commSize = 0;
-      ep_lib::MPI_Comm_size(*comm, &commSize);
+      MPI_Comm_size(*comm, &commSize);
       if (commSize <= 1)
         comm = NULL;
@@ -23,5 +23,5 @@
     // even if Parallel NetCDF ends up being used.
     if (mpi)
-      CNetCdfInterface::openPar(filename, NC_NOWRITE | NC_MPIIO, *comm, EP_INFO_NULL, this->ncidp);
+      CNetCdfInterface::openPar(filename, NC_NOWRITE | NC_MPIIO, *comm, MPI_INFO_NULL, this->ncidp);
     else
       CNetCdfInterface::open(filename, NC_NOWRITE, this->ncidp);
Index: XIOS/trunk/src/io/inetcdf4.hpp
===================================================================
--- XIOS/trunk/src/io/inetcdf4.hpp	(revision 1638)
+++ XIOS/trunk/src/io/inetcdf4.hpp	(revision 1639)
@@ -22,5 +22,5 @@
     public:
       /// Constructors ///
-      CINetCDF4(const StdString& filename, const ep_lib::MPI_Comm* comm = NULL, bool multifile = true,
+      CINetCDF4(const StdString& filename, const MPI_Comm* comm = NULL, bool multifile = true,
                 bool readMetaDataPar = false, const StdString& timeCounterName = "time_counter");
 
Index: XIOS/trunk/src/io/nc4_data_input.cpp
===================================================================
--- XIOS/trunk/src/io/nc4_data_input.cpp	(revision 1638)
+++ XIOS/trunk/src/io/nc4_data_input.cpp	(revision 1639)
@@ -10,5 +10,5 @@
 namespace xios
 {
-  CNc4DataInput::CNc4DataInput(const StdString& filename, ep_lib::MPI_Comm comm_file, bool multifile, bool isCollective /*= true*/,
+  CNc4DataInput::CNc4DataInput(const StdString& filename, MPI_Comm comm_file, bool multifile, bool isCollective /*= true*/,
                                bool readMetaDataPar /*= false*/, bool ugridConvention /*= false*/, const StdString& timeCounterName /*= "time_counter"*/)
     : SuperClass()
Index: XIOS/trunk/src/io/nc4_data_input.hpp
===================================================================
--- XIOS/trunk/src/io/nc4_data_input.hpp	(revision 1638)
+++ XIOS/trunk/src/io/nc4_data_input.hpp	(revision 1639)
@@ -23,5 +23,5 @@
 
     /// Constructors ///
-    CNc4DataInput(const StdString& filename, ep_lib::MPI_Comm comm_file, bool multifile, bool isCollective = true,
+    CNc4DataInput(const StdString& filename, MPI_Comm comm_file, bool multifile, bool isCollective = true,
                   bool readMetaDataPar = false, bool ugridConvention = false, const StdString& timeCounterName = "time_counter");
     CNc4DataInput(const CNc4DataInput& dataInput);       // Not implemented.
@@ -70,5 +70,5 @@
   private:
     /// Private attributes ///
-    ep_lib::MPI_Comm comm_file;
+    MPI_Comm comm_file;
     const StdString filename;
     bool isCollective;
Index: XIOS/trunk/src/io/nc4_data_output.cpp
===================================================================
--- XIOS/trunk/src/io/nc4_data_output.cpp	(revision 1638)
+++ XIOS/trunk/src/io/nc4_data_output.cpp	(revision 1639)
@@ -28,5 +28,5 @@
       CNc4DataOutput::CNc4DataOutput
          (CFile* file, const StdString & filename, bool exist, bool useClassicFormat, bool useCFConvention,
-          ep_lib::MPI_Comm comm_file, bool multifile, bool isCollective, const StdString& timeCounterName)
+          MPI_Comm comm_file, bool multifile, bool isCollective, const StdString& timeCounterName)
             : SuperClass()
             , SuperClassWriter(filename, exist, useClassicFormat, useCFConvention, &comm_file, multifile, timeCounterName)
Index: XIOS/trunk/src/io/nc4_data_output.hpp
===================================================================
--- XIOS/trunk/src/io/nc4_data_output.hpp	(revision 1638)
+++ XIOS/trunk/src/io/nc4_data_output.hpp	(revision 1639)
@@ -27,5 +27,5 @@
                (CFile* file, const StdString & filename, bool exist, bool useClassicFormat,
                 bool useCFConvention,
-                ep_lib::MPI_Comm comm_file, bool multifile, bool isCollective = true,
+                MPI_Comm comm_file, bool multifile, bool isCollective = true,
                 const StdString& timeCounterName = "time_counter");
 
@@ -117,5 +117,5 @@
 
             /// PropriÃ©tÃ©s privÃ©es ///
-            ep_lib::MPI_Comm comm_file;
+            MPI_Comm comm_file;
             const StdString filename;
             std::map<Time, StdSize> timeToRecordCache;
Index: XIOS/trunk/src/io/netCdfInterface.cpp
===================================================================
--- XIOS/trunk/src/io/netCdfInterface.cpp	(revision 1638)
+++ XIOS/trunk/src/io/netCdfInterface.cpp	(revision 1639)
@@ -10,5 +10,5 @@
 #include "netCdfInterface.hpp"
 #include "netCdfException.hpp"
-#include "ep_mpi.hpp"
+
 namespace xios
 {
@@ -47,11 +47,7 @@
 \return Status code
 */
-int CNetCdfInterface::createPar(const StdString& fileName, int cMode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId)
-{
-  #ifdef _usingMPI
+int CNetCdfInterface::createPar(const StdString& fileName, int cMode, MPI_Comm comm, MPI_Info info, int& ncId)
+{
   int status = xios::nc_create_par(fileName.c_str(), cMode, comm, info, &ncId);
-  #elif _usingEP
-  int status = xios::nc_create_par(fileName.c_str(), cMode, to_mpi_comm(comm->mpi_comm), to_mpi_info(info), &ncId);
-  #endif
   if (NC_NOERR != status)
   {
@@ -104,11 +100,7 @@
 \return Status code
 */
-int CNetCdfInterface::openPar(const StdString& fileName, int oMode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId)
-{
-  #ifdef _usingMPI
+int CNetCdfInterface::openPar(const StdString& fileName, int oMode, MPI_Comm comm, MPI_Info info, int& ncId)
+{
   int status = xios::nc_open_par(fileName.c_str(), oMode, comm, info, &ncId);
-  #elif _usingEP
-  int status = xios::nc_open_par(fileName.c_str(), oMode, to_mpi_comm(comm->mpi_comm), to_mpi_info(info), &ncId);
-  #endif
   if (NC_NOERR != status)
   {
Index: XIOS/trunk/src/io/netCdfInterface.hpp
===================================================================
--- XIOS/trunk/src/io/netCdfInterface.hpp	(revision 1638)
+++ XIOS/trunk/src/io/netCdfInterface.hpp	(revision 1639)
@@ -32,5 +32,5 @@
 
     //! Create a netcdf file on a parallel file system
-    static int createPar(const StdString& path, int cmode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId);
+    static int createPar(const StdString& path, int cmode, MPI_Comm comm, MPI_Info info, int& ncId);
 
     //! Open a netcdf file
@@ -38,5 +38,5 @@
 
     //! Open a netcdf file
-    static int openPar(const StdString& path, int cmode, ep_lib::MPI_Comm comm, ep_lib::MPI_Info info, int& ncId);
+    static int openPar(const StdString& path, int cmode, MPI_Comm comm, MPI_Info info, int& ncId);
 
     //! Close a netcdf file
Index: XIOS/trunk/src/io/onetcdf4.cpp
===================================================================
--- XIOS/trunk/src/io/onetcdf4.cpp	(revision 1638)
+++ XIOS/trunk/src/io/onetcdf4.cpp	(revision 1639)
@@ -15,5 +15,5 @@
       CONetCDF4::CONetCDF4(const StdString& filename, bool append, bool useClassicFormat,
 							bool useCFConvention,
-                           const ep_lib::MPI_Comm* comm, bool multifile, const StdString& timeCounterName)
+                           const MPI_Comm* comm, bool multifile, const StdString& timeCounterName)
         : path()
         , wmpi(false)
@@ -33,5 +33,5 @@
 
       void CONetCDF4::initialize(const StdString& filename, bool append, bool useClassicFormat, bool useCFConvention, 
-                                 const ep_lib::MPI_Comm* comm, bool multifile, const StdString& timeCounterName)
+                                 const MPI_Comm* comm, bool multifile, const StdString& timeCounterName)
       {
          this->useClassicFormat = useClassicFormat;
@@ -44,5 +44,5 @@
          {
             int commSize = 0;
-            ep_lib::MPI_Comm_size(*comm, &commSize);
+            MPI_Comm_size(*comm, &commSize);
             if (commSize <= 1)
                comm = NULL;
@@ -58,5 +58,5 @@
             CTimer::get("Files : create").resume();
             if (wmpi)
-               CNetCdfInterface::createPar(filename, mode, *comm, EP_INFO_NULL, this->ncidp);
+               CNetCdfInterface::createPar(filename, mode, *comm, MPI_INFO_NULL, this->ncidp);
             else
                CNetCdfInterface::create(filename, mode, this->ncidp);
@@ -70,5 +70,5 @@
             CTimer::get("Files : open").resume();
             if (wmpi)
-               CNetCdfInterface::openPar(filename, mode, *comm, EP_INFO_NULL, this->ncidp);
+               CNetCdfInterface::openPar(filename, mode, *comm, MPI_INFO_NULL, this->ncidp);
             else
                CNetCdfInterface::open(filename, mode, this->ncidp);
Index: XIOS/trunk/src/io/onetcdf4.hpp
===================================================================
--- XIOS/trunk/src/io/onetcdf4.hpp	(revision 1638)
+++ XIOS/trunk/src/io/onetcdf4.hpp	(revision 1639)
@@ -28,5 +28,5 @@
             CONetCDF4(const StdString& filename, bool append, bool useClassicFormat = false,
             		  bool useCFConvention = true,
-                      const ep_lib::MPI_Comm* comm = NULL, bool multifile = true,
+                      const MPI_Comm* comm = NULL, bool multifile = true,
                       const StdString& timeCounterName = "time_counter");
 
@@ -37,5 +37,5 @@
             /// Initialisation ///
             void initialize(const StdString& filename, bool append, bool useClassicFormat, bool useCFConvention,
-                            const ep_lib::MPI_Comm* comm, bool multifile, const StdString& timeCounterName);
+                            const MPI_Comm* comm, bool multifile, const StdString& timeCounterName);
             void close(void);
             void sync(void);