Index: XIOS/dev/dev_trunk_omp/src/interface/fortran_attr/iinterpolate_domain_attr.F90
===================================================================
--- XIOS/dev/dev_trunk_omp/src/interface/fortran_attr/iinterpolate_domain_attr.F90	(revision 1598)
+++ XIOS/dev/dev_trunk_omp/src/interface/fortran_attr/iinterpolate_domain_attr.F90	(revision 1646)
@@ -13,5 +13,5 @@
   SUBROUTINE xios(set_interpolate_domain_attr)  &
     ( interpolate_domain_id, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -27,4 +27,6 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: renormalize
       LOGICAL (KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL  , OPTIONAL, INTENT(IN) :: use_area
+      LOGICAL (KIND=C_BOOL) :: use_area_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: weight_filename
       LOGICAL  , OPTIONAL, INTENT(IN) :: write_weight
@@ -35,5 +37,5 @@
       CALL xios(set_interpolate_domain_attr_hdl_)   &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(set_interpolate_domain_attr)
@@ -41,5 +43,5 @@
   SUBROUTINE xios(set_interpolate_domain_attr_hdl)  &
     ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -54,4 +56,6 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: renormalize
       LOGICAL (KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL  , OPTIONAL, INTENT(IN) :: use_area
+      LOGICAL (KIND=C_BOOL) :: use_area_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: weight_filename
       LOGICAL  , OPTIONAL, INTENT(IN) :: write_weight
@@ -60,5 +64,5 @@
       CALL xios(set_interpolate_domain_attr_hdl_)  &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(set_interpolate_domain_attr_hdl)
@@ -66,5 +70,5 @@
   SUBROUTINE xios(set_interpolate_domain_attr_hdl_)   &
     ( interpolate_domain_hdl, detect_missing_value_, mode_, order_, quantity_, read_write_convention_  &
-    , renormalize_, weight_filename_, write_weight_ )
+    , renormalize_, use_area_, weight_filename_, write_weight_ )
 
     IMPLICIT NONE
@@ -79,4 +83,6 @@
       LOGICAL  , OPTIONAL, INTENT(IN) :: renormalize_
       LOGICAL (KIND=C_BOOL) :: renormalize__tmp
+      LOGICAL  , OPTIONAL, INTENT(IN) :: use_area_
+      LOGICAL (KIND=C_BOOL) :: use_area__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: weight_filename_
       LOGICAL  , OPTIONAL, INTENT(IN) :: write_weight_
@@ -116,4 +122,10 @@
       ENDIF
 
+      IF (PRESENT(use_area_)) THEN
+        use_area__tmp = use_area_
+        CALL cxios_set_interpolate_domain_use_area &
+      (interpolate_domain_hdl%daddr, use_area__tmp)
+      ENDIF
+
       IF (PRESENT(weight_filename_)) THEN
         CALL cxios_set_interpolate_domain_weight_filename &
@@ -131,5 +143,5 @@
   SUBROUTINE xios(get_interpolate_domain_attr)  &
     ( interpolate_domain_id, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -145,4 +157,6 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: renormalize
       LOGICAL (KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: use_area
+      LOGICAL (KIND=C_BOOL) :: use_area_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: weight_filename
       LOGICAL  , OPTIONAL, INTENT(OUT) :: write_weight
@@ -153,5 +167,5 @@
       CALL xios(get_interpolate_domain_attr_hdl_)   &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(get_interpolate_domain_attr)
@@ -159,5 +173,5 @@
   SUBROUTINE xios(get_interpolate_domain_attr_hdl)  &
     ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -172,4 +186,6 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: renormalize
       LOGICAL (KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: use_area
+      LOGICAL (KIND=C_BOOL) :: use_area_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: weight_filename
       LOGICAL  , OPTIONAL, INTENT(OUT) :: write_weight
@@ -178,5 +194,5 @@
       CALL xios(get_interpolate_domain_attr_hdl_)  &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(get_interpolate_domain_attr_hdl)
@@ -184,5 +200,5 @@
   SUBROUTINE xios(get_interpolate_domain_attr_hdl_)   &
     ( interpolate_domain_hdl, detect_missing_value_, mode_, order_, quantity_, read_write_convention_  &
-    , renormalize_, weight_filename_, write_weight_ )
+    , renormalize_, use_area_, weight_filename_, write_weight_ )
 
     IMPLICIT NONE
@@ -197,4 +213,6 @@
       LOGICAL  , OPTIONAL, INTENT(OUT) :: renormalize_
       LOGICAL (KIND=C_BOOL) :: renormalize__tmp
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: use_area_
+      LOGICAL (KIND=C_BOOL) :: use_area__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: weight_filename_
       LOGICAL  , OPTIONAL, INTENT(OUT) :: write_weight_
@@ -234,4 +252,10 @@
       ENDIF
 
+      IF (PRESENT(use_area_)) THEN
+        CALL cxios_get_interpolate_domain_use_area &
+      (interpolate_domain_hdl%daddr, use_area__tmp)
+        use_area_ = use_area__tmp
+      ENDIF
+
       IF (PRESENT(weight_filename_)) THEN
         CALL cxios_get_interpolate_domain_weight_filename &
@@ -249,5 +273,5 @@
   SUBROUTINE xios(is_defined_interpolate_domain_attr)  &
     ( interpolate_domain_id, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -266,4 +290,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: renormalize
       LOGICAL(KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: use_area
+      LOGICAL(KIND=C_BOOL) :: use_area_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: weight_filename
       LOGICAL(KIND=C_BOOL) :: weight_filename_tmp
@@ -275,5 +301,5 @@
       CALL xios(is_defined_interpolate_domain_attr_hdl_)   &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(is_defined_interpolate_domain_attr)
@@ -281,5 +307,5 @@
   SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl)  &
     ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-    , renormalize, weight_filename, write_weight )
+    , renormalize, use_area, weight_filename, write_weight )
 
     IMPLICIT NONE
@@ -297,4 +323,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: renormalize
       LOGICAL(KIND=C_BOOL) :: renormalize_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: use_area
+      LOGICAL(KIND=C_BOOL) :: use_area_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: weight_filename
       LOGICAL(KIND=C_BOOL) :: weight_filename_tmp
@@ -304,5 +332,5 @@
       CALL xios(is_defined_interpolate_domain_attr_hdl_)  &
       ( interpolate_domain_hdl, detect_missing_value, mode, order, quantity, read_write_convention  &
-      , renormalize, weight_filename, write_weight )
+      , renormalize, use_area, weight_filename, write_weight )
 
   END SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl)
@@ -310,5 +338,5 @@
   SUBROUTINE xios(is_defined_interpolate_domain_attr_hdl_)   &
     ( interpolate_domain_hdl, detect_missing_value_, mode_, order_, quantity_, read_write_convention_  &
-    , renormalize_, weight_filename_, write_weight_ )
+    , renormalize_, use_area_, weight_filename_, write_weight_ )
 
     IMPLICIT NONE
@@ -326,4 +354,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: renormalize_
       LOGICAL(KIND=C_BOOL) :: renormalize__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: use_area_
+      LOGICAL(KIND=C_BOOL) :: use_area__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: weight_filename_
       LOGICAL(KIND=C_BOOL) :: weight_filename__tmp
@@ -367,4 +397,10 @@
       ENDIF
 
+      IF (PRESENT(use_area_)) THEN
+        use_area__tmp = cxios_is_defined_interpolate_domain_use_area &
+      (interpolate_domain_hdl%daddr)
+        use_area_ = use_area__tmp
+      ENDIF
+
       IF (PRESENT(weight_filename_)) THEN
         weight_filename__tmp = cxios_is_defined_interpolate_domain_weight_filename &