Index: XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/average_reduction.hpp	(revision 1686)
@@ -33,4 +33,6 @@
   virtual ~CAverageReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Average reduction";}
+
 protected:
   CArray<double,1> weights_;
Index: XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/extract.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CExtractReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Extract reduction";}
+
 public:
   static bool registerTrans();
Index: XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/max_reduction.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CMaxReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Max reduction";}
+
 public:
   static bool registerTrans();
Index: XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/min_reduction.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CMinReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Min reduction";}
+
 public:
   static bool registerTrans();
Index: XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/reduction.hpp	(revision 1686)
@@ -57,4 +57,6 @@
   virtual ~CReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Reduction";}
+
 protected:
   typedef CReductionAlgorithm* (*CreateOperationCallBack)();
Index: XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/Functions/sum_reduction.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CSumReductionAlgorithm() {}
 
+  virtual StdString getName() {return "Sum reduction";}
+
 public:
   static bool registerTrans();
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_duplicate_scalar.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1686)
@@ -33,4 +33,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Duplicate Scalar";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract.hpp	(revision 1686)
@@ -27,4 +27,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Extract";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1686)
@@ -39,4 +39,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Extract Domain";}
+
 protected:
   enum ExtractDirection {
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_interpolate.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_interpolate.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_interpolate.hpp	(revision 1686)
@@ -32,4 +32,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Interpolation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_inverse.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_inverse.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_inverse.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Inverse";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_axis.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1686)
@@ -39,4 +39,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Axis";}
 protected:
   
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1686)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Domain";}
+
 protected:
   enum ReduceDirection {
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_temporal_splitting.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1686)
@@ -34,4 +34,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Temporal Splitting";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_transformation.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_transformation.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CAxisAlgorithmTransformation();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/axis_algorithm_zoom.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/axis_algorithm_zoom.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/axis_algorithm_zoom.hpp	(revision 1686)
@@ -27,4 +27,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Zoom";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_compute_connectivity.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1686)
@@ -28,4 +28,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Compute Connectivity";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_expand.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_expand.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_expand.hpp	(revision 1686)
@@ -28,4 +28,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Expand";}
 
 protected:
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_extract.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_extract.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_extract.hpp	(revision 1686)
@@ -23,4 +23,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Extract";}
 protected:
   void updateDomainAttributes();
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_generate_rectilinear.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_generate_rectilinear.hpp	(revision 1686)
@@ -33,4 +33,6 @@
   virtual ~CDomainAlgorithmGenerateRectilinear() {}
 
+  virtual StdString getName() {return "Domain Trans. Filter \\n Generate Rectilinear";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_interpolate.hpp	(revision 1686)
@@ -39,4 +39,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Interpolation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_reorder.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_reorder.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_reorder.hpp	(revision 1686)
@@ -26,4 +26,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Domain Trans. Filter \\n Reorder";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_transformation.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_transformation.hpp	(revision 1686)
@@ -27,4 +27,6 @@
   virtual ~CDomainAlgorithmTransformation();
 
+  virtual StdString getName() {return "Domain Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >&);
Index: XIOS/dev/dev_olga/src/transformation/domain_algorithm_zoom.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/domain_algorithm_zoom.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/domain_algorithm_zoom.hpp	(revision 1686)
@@ -23,4 +23,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Zoom";}
 protected:
   void updateDomainAttributes();
Index: XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp	(revision 1686)
@@ -73,4 +73,6 @@
                      std::vector<bool>& flagInitial,                     
                      bool ignoreMissingValue, bool firstPass);
+
+  virtual StdString getName() {return "Generic Trans. Filter";}
 
   /*!
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1686)
@@ -39,4 +39,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Extract Axis";}
+
 protected:
   int pos_;
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1686)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-#include "reduction.hpp"
 
 #include "reduction.hpp"
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1686)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Axis";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1686)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Domain";}
+
 protected:
   bool local ;
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_scalar.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1686)
@@ -35,4 +35,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Scalar";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_olga/src/transformation/scalar_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_olga/src/transformation/scalar_algorithm_transformation.hpp	(revision 1653)
+++ XIOS/dev/dev_olga/src/transformation/scalar_algorithm_transformation.hpp	(revision 1686)
@@ -31,4 +31,6 @@
   virtual ~CScalarAlgorithmTransformation();
 
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);